(defun fnx (f n x)
  (if (> n 0)
      (format nil "f(~d)" (fnx f (- n 1) x))
    x))

(defun gcn (n)
  (if (> n 0)
      (format nil "g(~d)" (gcn (- n 1)))
    "c"))

(defun k2 (n)
  (let ((f (open (format nil "/home/chad/feb2021/k2_~d.p" n) :direction :output :if-exists :supersede)))
    (format f "fof(atmost2,axiom,(! [X,Y,Z] : (X = Y | X = Z | Y = Z))).~%")
    (format f "fof(kam2_~d,conjecture,(f(f(f(~d))) = f(~d))).~%" n (gcn n) (gcn n))
    (close f)))

(defun k3 (n)
  (let ((f (open (format nil "/home/chad/feb2021/k3_~d.p" n) :direction :output :if-exists :supersede)))
    (format f "fof(atmost3,axiom,(! [X,Y,Z,W] : (X = Y | X = Z | X = W | Y = Z | Y = W | Z = W))).~%")
    (format f "fof(kam3_~d,conjecture,(~d = ~d)).~%" n (fnx "f" 8 (gcn n)) (fnx "f" 2 (gcn n)))
    (close f)))

(defun k4 (n)
  (let ((f (open (format nil "/home/chad/feb2021/k4_~d.p" n) :direction :output :if-exists :supersede)))
    (format f "fof(atmost4,axiom,(! [X,Y,Z,W,U] : (X = Y | X = Z | X = W | X = U | Y = Z | Y = W | Y = U | Z = W | Z = U | W = U))).~%")
    (format f "fof(kam4_~d,conjecture,(~d = ~d)).~%" n (fnx "f" 15 (gcn n)) (fnx "f" 3 (gcn n)))
    (close f)))

(defun k5 (n)
  (let ((f (open (format nil "/home/chad/feb2021/k5_~d.p" n) :direction :output :if-exists :supersede)))
    (format f "fof(atmost5,axiom,(! [X,Y,Z,W,U,V] : (X = Y | X = Z | X = W | X = U | X = V | Y = Z | Y = W | Y = U | Y = V | Z = W | Z = U | Z = V | W = U | W = V | U = V))).~%")
    (format f "fof(kam5_~d,conjecture,(~d = ~d)).~%" n (fnx "f" 64 (gcn n)) (fnx "f" 4 (gcn n)))
    (close f)))

(defun k2d (n)
  (let ((f (open (format nil "/home/chad/feb2021/k2d_~d.p" n) :direction :output :if-exists :supersede)))
    (format f "fof(atmost2,axiom,(! [X,Y,Z] : (X = Y | X = Z | Y = Z))).~%")
    (let ((instl nil))
      (dotimes (xm 4)
	(dotimes (ym 4)
	  (dotimes (zm 4)
	    (push (list (fnx "f" xm (gcn n)) (fnx "f" ym (gcn n)) (fnx "f" zm (gcn n))) instl))))
      (dotimes (i (length instl))
	(let* ((theta (nth i instl))
	       (x (nth 0 theta))
	       (y (nth 1 theta))
	       (z (nth 2 theta)))
	  (format f "fof(atmost2_~d,axiom,(~d = ~d | ~d = ~d | ~d = ~d)).~%" i x y x z y z))))
    (format f "fof(kam2_~d,conjecture,(f(f(f(~d))) = f(~d))).~%" n (gcn n) (gcn n))
    (close f)))

(defun k3d (n)
  (let ((f (open (format nil "/home/chad/feb2021/k3d_~d.p" n) :direction :output :if-exists :supersede)))
    (format f "fof(atmost3,axiom,(! [X,Y,Z,W] : (X = Y | X = Z | X = W | Y = Z | Y = W | Z = W))).~%")
    (let ((instl nil))
      (dolist (xm '(0 1 2 6 7 8))
	(dolist (ym '(0 1 2 6 7 8))
	  (dolist (zm '(0 1 2 6 7 8))
	    (dolist (wm '(0 1 2 6 7 8))
	      (push (list (fnx "f" xm (gcn n)) (fnx "f" ym (gcn n)) (fnx "f" zm (gcn n)) (fnx "f" wm (gcn n))) instl)))))
      (dotimes (i (length instl))
	(let* ((theta (nth i instl))
	       (x (nth 0 theta))
	       (y (nth 1 theta))
	       (z (nth 2 theta))
	       (w (nth 3 theta)))
	  (format f "fof(atmost3_~d,axiom,(~d = ~d | ~d = ~d | ~d = ~d | ~d = ~d | ~d = ~d | ~d = ~d)).~%" i x y x z x w y z y w z w))))
    (format f "fof(kam3_~d,conjecture,(~d = ~d)).~%" n (fnx "f" 8 (gcn n)) (fnx "f" 2 (gcn n)))
    (close f)))

(defun k4d (n)
  (let ((f (open (format nil "/home/chad/feb2021/k4d_~d.p" n) :direction :output :if-exists :supersede)))
    (format f "fof(atmost4,axiom,(! [X,Y,Z,W,U] : (X = Y | X = Z | X = W | X = U | Y = Z | Y = W | Y = U | Z = W | Z = U | W = U))).~%")
    (let ((instl nil))
      (dolist (xm '(0 1 2 3 12 13 14 15))
	(dolist (ym '(0 1 2 3 12 13 14 15))
	  (dolist (zm '(0 1 2 3 12 13 14 15))
	    (dolist (wm '(0 1 2 3 12 13 14 15))
	      (dolist (um '(0 1 2 3 12 13 14 15))
		(push (list (fnx "f" xm (gcn n)) (fnx "f" ym (gcn n)) (fnx "f" zm (gcn n)) (fnx "f" wm (gcn n)) (fnx "f" um (gcn n))) instl))))))
      (dotimes (i (length instl))
	(let* ((theta (nth i instl))
	       (x (nth 0 theta))
	       (y (nth 1 theta))
	       (z (nth 2 theta))
	       (w (nth 3 theta))
	       (u (nth 4 theta)))
	  (format f "fof(atmost4_~d,axiom,(~d = ~d | ~d = ~d | ~d = ~d | ~d = ~d | ~d = ~d | ~d = ~d | ~d = ~d | ~d = ~d | ~d = ~d | ~d = ~d)).~%" i x y x z x w x u y z y y u w z w z u w u))))
    (format f "fof(kam4_~d,conjecture,(~d = ~d)).~%" n (fnx "f" 15 (gcn n)) (fnx "f" 3 (gcn n)))
    (close f)))

(defun k2d1 (n)
  (let ((f (open (format nil "/home/chad/feb2021/k2d1_~d.p" n) :direction :output :if-exists :supersede)))
    (format f "fof(atmost2,axiom,(! [X,Y,Z] : (X = Y | X = Z | Y = Z))).~%")
    (let ((instl nil))
      (dotimes (xm 4)
	(push (list (fnx "f" xm (gcn n))) instl))
      (dotimes (i (length instl))
	(let* ((theta (nth i instl))
	       (x (nth 0 theta)))
	  (format f "fof(atmost2_~d,axiom,(! [Y,Z] : (~d = Y| ~d = Z | Y = Z))).~%" i x x))))
    (format f "fof(kam2_~d,conjecture,(f(f(f(~d))) = f(~d))).~%" n (gcn n) (gcn n))
    (close f)))

(defun k3d1 (n)
  (let ((f (open (format nil "/home/chad/feb2021/k3d1_~d.p" n) :direction :output :if-exists :supersede)))
    (format f "fof(atmost3,axiom,(! [X,Y,Z,W] : (X = Y | X = Z | X = W | Y = Z | Y = W | Z = W))).~%")
    (let ((instl nil))
      (dolist (xm '(0 1 2 6 7 8))
	(push (list (fnx "f" xm (gcn n))) instl))
      (dotimes (i (length instl))
	(let* ((theta (nth i instl))
	       (x (nth 0 theta)))
	  (format f "fof(atmost3_~d,axiom,(! [Y,Z,W] : (~d = Y | ~d = Z | ~d = W | Y = Z | Y = W | Z = W))).~%" i x x x))))
    (format f "fof(kam3_~d,conjecture,(~d = ~d)).~%" n (fnx "f" 8 (gcn n)) (fnx "f" 2 (gcn n)))
    (close f)))

(defun k4d1 (n)
  (let ((f (open (format nil "/home/chad/feb2021/k4d1_~d.p" n) :direction :output :if-exists :supersede)))
    (format f "fof(atmost4,axiom,(! [X,Y,Z,W,U] : (X = Y | X = Z | X = W | X = U | Y = Z | Y = W | Y = U | Z = W | Z = U | W = U))).~%")
    (let ((instl nil))
      (dolist (xm '(0 1 2 3 12 13 14 15))
	(push (list (fnx "f" xm (gcn n))) instl))
      (dotimes (i (length instl))
	(let* ((theta (nth i instl))
	       (x (nth 0 theta)))
	  (format f "fof(atmost4_~d,axiom,(! [Y,Z,W,U] : (~d = Y | ~d = Z | ~d = W | ~d = U | Y = Z | Y = W | Y = U | Z = W | Z = U | W = U))).~%" i x x x x))))
    (format f "fof(kam4_~d,conjecture,(~d = ~d)).~%" n (fnx "f" 15 (gcn n)) (fnx "f" 3 (gcn n)))
    (close f)))

(defun allfuncs (n m)
  (if (> n 0)
      (let ((fl (allfuncs (- n 1) m))
	    (r nil))
	(dotimes (j m r)
	  (dolist (f fl)
	    (push (append f (list j)) r))))
    '(nil)))

(defun id (n) (let ((r nil)) (dotimes (i n (reverse r)) (push i r))))
(defun pow (n m x) (if (> m 0) (comp n (pow n (- m 1) x) x) (id n)))
(defun comp (n x y) (let ((z nil)) (dotimes (i n) (push (nth (nth i x) y) z)) (reverse z)))

(defun counterkam (n i j)
  (let ((fl (allfuncs n n)))
    (find-if
     #'(lambda (f)
	 (not (equal (pow n i f) (pow n j f))))
     fl)))

(defun lcm-upto (m &optional args)
  (if (> m 1)
      (lcm-upto (- m 1) (cons m args))
    (eval (cons 'lcm args))))
  
(defun kam (m n)
  (let ((f (open (format nil "/home/chad/jun2021cvc/k_~d_~d.p" m n) :direction :output :if-exists :supersede)))
    (format f "fof(atmost~d,axiom,(! [" m)
    (dotimes (i (1+ m)) (unless (= i 0) (format f ",")) (format f "V~d" i))
    (format f "] : (")
    (dotimes (j (1+ m)) (dotimes (i j) (unless (and (= i 0) (= j 1)) (format f " | ")) (format f "V~d = V~d" i j)))
    (format f "))).~%")
    (format f "fof(kam_~d_~d,conjecture,(~d = ~d)).~%" m n (fnx "f" (+ (lcm-upto m) (- m 1)) (gcn n)) (fnx "f" (- m 1) (gcn n)))
    (close f)))

					; (dotimes (m 11) (when (> m 3) (dotimes (n 100) (kam m n))))
