(defun fnx (f n x)
  (if (> n 0)
      (format nil "f(~d)" (fnx f (- n 1) x))
    x))

(defun gcn (n)
  (if (> n 0)
      (format nil "g(~d)" (gcn (- n 1)))
    "c"))

(defun k2 (n)
  (let ((f (open (format nil "/home/chad/feb2021/k2_~d.p" n) :direction :output :if-exists :supersede)))
    (format f "fof(atmost2,axiom,(! [X,Y,Z] : (X = Y | X = Z | Y = Z))).~%")
    (format f "fof(kam2_~d,conjecture,(f(f(f(~d))) = f(~d))).~%" n (gcn n) (gcn n))
    (close f)))

(defun k3 (n)
  (let ((f (open (format nil "/home/chad/feb2021/k3_~d.p" n) :direction :output :if-exists :supersede)))
    (format f "fof(atmost3,axiom,(! [X,Y,Z,W] : (X = Y | X = Z | X = W | Y = Z | Y = W | Z = W))).~%")
    (format f "fof(kam3_~d,conjecture,(~d = ~d)).~%" n (fnx "f" 15 (gcn n)) (fnx "f" 3 (gcn n)))
    (close f)))

(defun k4 (n)
  (let ((f (open (format nil "/home/chad/feb2021/k4_~d.p" n) :direction :output :if-exists :supersede)))
    (format f "fof(atmost4,axiom,(! [X,Y,Z,W,U] : (X = Y | X = Z | X = W | X = U | Y = Z | Y = W | Y = U | Z = W | Z = U | W = U))).~%")
    (format f "fof(kam4_~d,conjecture,(~d = ~d)).~%" n (fnx "f" 96 (gcn n)) (fnx "f" 4 (gcn n)))
    (close f)))

(defun allfuncs (n m)
  (if (> n 0)
      (let ((fl (allfuncs (- n 1) m))
	    (r nil))
	(dotimes (j m r)
	  (dolist (f fl)
	    (push (append f (list j)) r))))
    '(nil)))

(defun id (n) (let ((r nil)) (dotimes (i n (reverse r)) (push i r))))
(defun pow (n m x) (if (> m 0) (comp n (pow n (- m 1) x) x) (id n)))
(defun comp (n x y) (let ((z nil)) (dotimes (i n) (push (nth (nth i x) y) z)) (reverse z)))

(defun counterkam (n i j)
  (let ((fl (allfuncs n n)))
    (find-if
     #'(lambda (f)
	 (not (equal (pow n i f) (pow n j f))))
     fl)))
